{% extends 'base.html' %} {% block content %} {% load static %}
{% load humanize %}
<div class="container">
  <h2 class="">
    Keranjang Belanja
  </h2>
  <div class="row mt-3">
    {% if keranjang %}
        <table class="table table-striped">
        <thead>
            <tr>
            <th scope="col">Barang</th>
            <th scope="col">Qty</th>
            <th scope="col">Harga</th>
            <th scope="col">Actions</th>
            </tr>
        </thead>
        <tbody>
        {% for barang in keranjang.entry.all %}
        <tr>
        <td>{{barang.barang.nama}}</td>
        <td>
            <form class="jumlah-form">
                <input type="hidden" name="id" value="{{barang.id}}">
            <input type="number" name="jumlah" value="{{barang.jumlah}}" min=1 max={{barang.barang.stok}}>
            <button type="submit" class="btn btn-success btn-update">Update</button>
            </form>
        </td>
        <td>Rp. {{barang.harga_total|intcomma}}</td>
        <td><button class="btn btn-danger btn-hapus" data-barang-id="{{barang.id}}">Hapus</button></td>
        </tr>
        {% endfor %}
        </tbody>
        </table>
        <a href="{% url 'transaksi:transaksi-cepat' %}" class="btn btn-info">Checkout | Transaksi Cepat</a>
    {% else %}
    Anda tidak memiliki keranjang belanja!
    {% endif %}
  </div>
</div>

{% load static %} {% endblock %} {% block head %}
<title>Keranjang | Tk.PePeW Online Shop</title>
<link rel="stylesheet" href="https://unpkg.com/swiper/css/swiper.min.css" />

{% endblock %}
{% block js %}
<script>
    $(function() {
        $(".jumlah-form").submit(async function(e) {
            e.preventDefault();
            const jumlah = e.target.jumlah.value
            const id = e.target.id.value

            const data = {
                id,
                jumlah
            }

            const csrftoken = Cookies.get('csrftoken');
            const response = await fetch(`{% url 'keranjang:update-jumlah' %}`, {
                method: 'POST',
                body: JSON.stringify(data),
                headers: { "X-CSRFToken": csrftoken },
            });

            const result = await response.json();

            const notyf = new Notyf();
            if (result.success) {
                notyf.success(`Kuantitas sukses diupdate!`);
                e.target.id.value = result.entry.jumlah;
                e.target.jumlah.readOnly = true;
            } else {
                notyf.error(`Kuantitas gagal diupdate!`);
                notyf.error(result.error);
            }
        });

        $(".btn-hapus").click(async function() {
            const id = this.dataset.barangId;

            const data = {
                id
            }

            const csrftoken = Cookies.get('csrftoken');
            const response = await fetch(`{% url 'keranjang:hapus' %}`, {
                method: 'POST',
                body: JSON.stringify(data),
                headers: { "X-CSRFToken": csrftoken },
            });

            const result = await response.json();

            const notyf = new Notyf();
            if (result.success) {
                notyf.success(`Barang berhasil dihapus!`);
                $(this).parents("tr").remove();
            } else {
                notyf.error(`Barang gagal dihapus!`);
                notyf.error(result.error);
            }
        });
    });
</script>
{% endblock%}